!c Description:
!c   ͤ⾯ʤʤäǤ򥫥å
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-03-01    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_chk_emol
  interface
     
     subroutine chk_emol(emol, struct, EPSZ, ssw, esw, sw)
       real(8), intent(in)               :: emol(:)
       real(8), intent(in)               :: EPSZ
       real(8), intent(in)               :: struct(:,:)
       logical, intent(out), allocatable :: ssw(:)
       logical, intent(out), allocatable :: esw(:)
       logical, intent(out)              :: sw
     end subroutine chk_emol
     
  end interface
end module interface_chk_emol




subroutine chk_emol(emol, struct, EPSZ, ssw, esw, sw)
  implicit none
  real(8), intent(in)               :: emol(:)  
  real(8), intent(in)               :: EPSZ
  real(8), intent(in)               :: struct(:,:)
  logical, intent(out), allocatable :: ssw(:)
  logical, intent(out), allocatable :: esw(:)
  logical, intent(out)              :: sw
  
  real(8), allocatable              :: emolfr(:)  !ǤΥ
  integer                           :: e, s
  integer                           :: N, M


!!!
!!!ͺ
!!!
  N = size(struct, 1)
  M = size(struct, 2)

  if (allocated(ssw)) deallocate(ssw)
  if (allocated(esw)) deallocate(esw)
  allocate(ssw(N), esw(M), emolfr(M))
  ssw = .true.; esw = .true.; sw = .false. 
  emolfr = emol / sum(emol)

  
!!!
!!!Ǥ¸̤ EPSZ 礭ɤȽꤹ
!!!⤷⾮, εκŽʪ psw ڤ
!!!
  do e = 1, M
     if (emolfr(e) <= EPSZ) then 
        esw(e) = .false. 
        sw = .true. 
        do s = 1, N
           if (struct(s, e) > 0.0d0)  ssw(s) = .false.
        end do
     end if
  end do

!!!
!!!դ
!!!
  deallocate(emolfr)

end subroutine chk_emol
